<?php

class SalesController extends Zend_Controller_Action
{

    public function init()
    {
         $this->_helper->contextSwitch()
                      ->addActionContext('breakdown', array('json'))
                      ->setAutoJsonSerialization(true)
                      ->initContext('json');
        return;
    }

    public function indexAction()
    {
        // action body
    }

    public function breakdownAction()
    {
        $commonSession = new Zend_Session_Namespace('common');
        $payload = array();

        /*
         * Get the incoming payload
         */
        $data = $this->_request->getParam('data');
        $data = json_decode($data);

        /*
         * before proceeding, check for a valid session id. If anything has
         * changed, sessionID on PHP, the toekn being passed in or the IP
         * address of the client, take it as a warning and bail.
         */

        $token=md5(session_id().$data->t.$_SERVER['REMOTE_ADDR']);

        if ($commonSession->token===$token) {

            /*
             * Setup the filter for any incoming data
             */
            $allNumfilter = new Zend_Filter_Alnum();
            
            /*
             * Setup an array of query parameters comtaining the filtered data
             */
            $parameters = array();
            
            $parameters['startDate'] = date('Y-m-d',strtotime($data->p[0]));
            $parameters['endDate']   = date('Y-m-d',strtotime($data->p[1]));
            $parameters['countries'] = $allNumfilter->filter($data->p[2]);
            $parameters['handlers']  = $allNumfilter->filter($data->p[3]);
            $parameters['skus']      = $allNumfilter->filter($data->p[4]);
    
            try {
                /*
                 * Call the SalesReporter
                 */
                $db = $this->getFrontController()
                           ->getParam('bootstrap')
                           ->getPluginResource('db')
                           ->getDbAdapter();
                           
                $salesReporter = new Application_Model_SalesReporter($db);
                $results       = $salesReporter->fetchSales($parameters);
                /*
                 * Prepare the outbound payload
                 */ 
                $payload['f'] = false;// failure flag
                $payload['r'] = $results; // the actual payload
                $payload['m'] = '' ; // a place for messages to go back to the client            
            } catch (Exception $e) {
                $payload['f'] = true;// failure flag
                $payload['m'] = $e->getMessage() ; // a place for messages to go back to the client                            
            } // try
            
        } else {
            /*
             * If the token passed in did not match, let the client know.
             */
            $payload['f'] = true;// failure flag
            $payload['m'] = 'Token Mismatch! YOU GO NOW!' ; // a place for messages to go back to the client            
        }
        
        $this->_helper->json($payload);
        return;
    } // if ($commonSession->token!==$token) 

}



