<?php

class UserController extends Zend_Controller_Action
{

    public function init()
    {
        $this->_helper->contextSwitch()
                      ->addActionContext('login', array('json'))
                      ->setAutoJsonSerialization(true)
                      ->initContext('json');
    }

    public function indexAction()
    {
        // action body
    }

    public function loginAction()
    {
        $commonSession = new Zend_Session_Namespace('common');
        /*
         * If the user is requesting a login, regardless of the status of the
         * session, clear out the current token. Either the login will succeed
         * and you can issue them a new token, or it will fail, in which case,
         * you don't want them to have access anymore.
         *
         * Since this is really dummy logic, I am not bothering to break it into
         * objects. needless to say, you would at the very least want a User
         * Object that controls the login process.
         */
        $commonSession->token = null;
        
        /*
         * Now grab the incoming payload
         */
        $data = $this->_request->getParam('data');
        $data = json_decode($data);
        /*
         * Authentication code goes here. Assuming everything went ok and their
         * credentials checked out, let's give them back what they need to
         * continue.
         */
        session_regenerate_id(true);
        $commonSession->token = md5(session_id().$data->t.$_SERVER['REMOTE_ADDR']);
        $payload = array();
        $payload['f'] = false;
        $this->_helper->json($payload);
        return;
    }

}



