<?php

class Application_Model_SalesReporter
{
    protected $_db;
    
    public function __construct($db)
    {
        $this->_db = $db;
        return;
    }
    
    public function fetchSales($parameters)
    {
        if (is_null($this->_db)) {
            throw Exception('No database connection provided, cannot continue',1);
        }
        /*
         * Now build the query for the database
         */
        $select = $this->_db->select()
                            ->from(array('oi'=>'orderItem',),
                                   array('oi.price',
                                         'oi.quantity',
                                         'oi.sku',
                                         'oi.productName')
                                  )
                            ->joinleft(array('o'=>'order'),
                                             'oi.orderId = o.id',array())
                            ->where('o.state=11')
                            ->where("o.ts BETWEEN '{$parameters['startDate']}' AND '{$parameters['endDate']}' ");

        /*
         * Optional parameters only added to the query if specified.
         */
        if (is_array($parameters['handlers']) and !empty($parameters['handlers'])) {
            $select->where('oi.handlerName IN (?)',implode(',',$parameters['handlers'])); 
        }
        
        if (is_array($parameters['skus']) and !empty($parameters['skus'])) {
            $select->where('oi.sku IN (?)',implode(',',$parameters['skus'])); 
        }
        
        if (is_array($parameters['skus']) and !empty($parameters['skus'])) {
            $select->where('oi.sku IN (?)',implode(',',$parameters['skus'])); 
        }
        
        if (is_array($parameters['countries']) and !empty($parameters['countries'])) {
            $select->where('uid IN (SELECT uid
                                      FROM address
                                     WHERE country IN (?))',implode(',',$parameters['countries'])); 
        }
            
        /*
         * Prepare the query, execute it, and get the resultset.
         */
        $stmt = $select->query();
        $result = $stmt->fetchAll();
        return $result;
    }
    
}

